## mupdf 0.7

=== Makefile ===
# GNU Makefile for MuPDF
#
# make build=release prefix=/usr/local verbose=true install
#

default: all

build ?= debug
prefix ?= /usr/local

OBJDIR := build/$(build)
GENDIR := build/generated

$(OBJDIR):
	mkdir -p $@
$(GENDIR):
	mkdir -p $@

# If no pregen directory is supplied, then generate (dump) the
# font and cmap .c files as part of the build.
# If it is supplied, then just use the files from that directory.

pregen := $(wildcard pregen)

ifneq "$(pregen)" ""
GENDIR := $(pregen)
endif

# Compiler flags and configuration options are kept in Makerules.
# Thirdparty libs will be built by Makethird if the thirdparty
# directory exists.

LIBS := -lfreetype -ljbig2dec -lopenjpeg -ljpeg -lz -lm

include Makerules
include Makethird

CFLAGS += $(THIRD_INCS) $(SYS_FREETYPE_INC)

#
# Build commands
#

ifneq "$(verbose)" ""

GENFILE_CMD = $(firstword $^) $@ $(wordlist 2, 999, $^)
CC_CMD = $(CC) -o $@ -c $< $(CFLAGS)
LD_CMD = $(CC) -o $@ $^ $(LDFLAGS) $(LIBS)
AR_CMD = rm -f $@ && $(AR) cru $@ $^

else

GENFILE_CMD = @ echo GENFILE $@ && $(firstword $^) $@ $(wordlist 2, 999, $^)
CC_CMD = @ echo CC $@ && $(CC) -o $@ -c $< $(CFLAGS)
LD_CMD = @ echo LD $@ && $(CC) -o $@ $^ $(LDFLAGS) $(LIBS)
AR_CMD = @ echo AR $@ && rm -f $@ && $(AR) cru $@ $^

endif

#
# Code generation tools
#

FONTDUMP_EXE := $(OBJDIR)/fontdump
$(FONTDUMP_EXE): $(OBJDIR)/fontdump.o
	$(LD_CMD)

CMAPDUMP_EXE := $(OBJDIR)/cmapdump
$(CMAPDUMP_EXE): $(OBJDIR)/cmapdump.o
	$(LD_CMD)

#
# Sources
#

FITZ_HDR := fitz/fitz.h
FITZ_SRC := \
	fitz/base_error.c \
	fitz/base_geometry.c \
	fitz/base_getopt.c \
	fitz/base_hash.c \
	fitz/base_memory.c \
	fitz/base_string.c \
	fitz/base_time.c \
	fitz/crypt_aes.c \
	fitz/crypt_arc4.c \
	fitz/crypt_md5.c \
	fitz/dev_bbox.c \
	fitz/dev_draw.c \
	fitz/dev_list.c \
	fitz/dev_null.c \
	fitz/dev_text.c \
	fitz/dev_trace.c \
	fitz/filt_basic.c \
	fitz/filt_dctd.c \
	fitz/filt_faxd.c \
	fitz/filt_flate.c \
	fitz/filt_jbig2d.c \
	fitz/filt_jpxd.c \
	fitz/filt_lzwd.c \
	fitz/filt_predict.c \
	fitz/obj_array.c \
	fitz/obj_dict.c \
	fitz/obj_print.c \
	fitz/obj_simple.c \
	fitz/res_colorspace.c \
	fitz/res_font.c \
	fitz/res_path.c \
	fitz/res_pixmap.c \
	fitz/res_shade.c \
	fitz/res_text.c \
	fitz/stm_buffer.c \
	fitz/stm_open.c \
	fitz/stm_read.c
FITZ_OBJ := $(FITZ_SRC:fitz/%.c=$(OBJDIR)/%.o)
$(FITZ_OBJ): $(FITZ_HDR)

DRAW_SRC := $(DRAW_ARCH_SRC) \
	draw/archport.c \
	draw/blendmodes.c \
	draw/glyphcache.c \
	draw/imagedraw.c \
	draw/imagescale.c \
	draw/imagesmooth.c \
	draw/imageunpack.c \
	draw/meshdraw.c \
	draw/pathfill.c \
	draw/pathscan.c \
	draw/pathstroke.c \
	draw/porterduff.c
DRAW_OBJ := $(DRAW_SRC:draw/%.c=$(OBJDIR)/%.o)
DRAW_OBJ := $(DRAW_OBJ:draw/%.s=$(OBJDIR)/%.o)
$(DRAW_OBJ): $(FITZ_HDR)

MUPDF_HDR := $(FITZ_HDR) mupdf/mupdf.h
MUPDF_SRC := \
	mupdf/pdf_annot.c \
	mupdf/pdf_build.c \
	mupdf/pdf_cmap.c \
	mupdf/pdf_cmap_load.c \
	mupdf/pdf_cmap_parse.c \
	mupdf/pdf_cmap_table.c \
	mupdf/pdf_colorspace.c \
	mupdf/pdf_crypt.c \
	mupdf/pdf_debug.c \
	mupdf/pdf_font.c \
	mupdf/pdf_fontagl.c \
	mupdf/pdf_fontenc.c \
	mupdf/pdf_fontfile.c \
	mupdf/pdf_fontmtx.c \
	mupdf/pdf_function.c \
	mupdf/pdf_image.c \
	mupdf/pdf_interpret.c \
	mupdf/pdf_lex.c \
	mupdf/pdf_nametree.c \
	mupdf/pdf_outline.c \
	mupdf/pdf_page.c \
	mupdf/pdf_pagetree.c \
	mupdf/pdf_parse.c \
	mupdf/pdf_pattern.c \
	mupdf/pdf_repair.c \
	mupdf/pdf_shade.c \
	mupdf/pdf_store.c \
	mupdf/pdf_stream.c \
	mupdf/pdf_type3.c \
	mupdf/pdf_unicode.c \
	mupdf/pdf_xobject.c \
	mupdf/pdf_xref.c
MUPDF_OBJ := $(MUPDF_SRC:mupdf/%.c=$(OBJDIR)/%.o)
$(MUPDF_OBJ): $(MUPDF_HDR)

$(OBJDIR)/%.o: fitz/%.c
	$(CC_CMD)
$(OBJDIR)/%.o: draw/%.c
	$(CC_CMD)
$(OBJDIR)/%.o: draw/%.s
	$(CC_CMD)
$(OBJDIR)/%.o: mupdf/%.c
	$(CC_CMD)
$(OBJDIR)/%.o: $(GENDIR)/%.c
	$(CC_CMD)

#
# Generated font file dumps
#

BASEFONT_FILES := \
	fonts/Dingbats.cff \
	fonts/NimbusMonL-Bold.cff \
	fonts/NimbusMonL-BoldObli.cff \
	fonts/NimbusMonL-Regu.cff \
	fonts/NimbusMonL-ReguObli.cff \
	fonts/NimbusRomNo9L-Medi.cff \
	fonts/NimbusRomNo9L-MediItal.cff \
	fonts/NimbusRomNo9L-Regu.cff \
	fonts/NimbusRomNo9L-ReguItal.cff \
	fonts/NimbusSanL-Bold.cff \
	fonts/NimbusSanL-BoldItal.cff \
	fonts/NimbusSanL-Regu.cff \
	fonts/NimbusSanL-ReguItal.cff \
	fonts/StandardSymL.cff \
	fonts/URWChanceryL-MediItal.cff

CJKFONT_FILES := \
	fonts/droid/DroidSansFallback.ttf

ifeq "$(pregen)" ""

$(GENDIR)/font_base14.c: $(FONTDUMP_EXE) $(BASEFONT_FILES)
	$(GENFILE_CMD)
$(GENDIR)/font_cjk.c: $(FONTDUMP_EXE) $(CJKFONT_FILES)
	$(GENFILE_CMD)

endif

FONT_SRC := \
	$(GENDIR)/font_base14.c \
	$(GENDIR)/font_cjk.c

FONT_OBJ := $(FONT_SRC:$(GENDIR)/%.c=$(OBJDIR)/%.o)


#
# Generated CMap file dumps
#

CMAP_UNICODE_FILES := $(addprefix cmaps/, \
	Adobe-CNS1-UCS2 Adobe-GB1-UCS2 \
	Adobe-Japan1-UCS2 Adobe-Korea1-UCS2 )

CMAP_CNS_FILES := $(addprefix cmaps/, \
	Adobe-CNS1-0 Adobe-CNS1-1 Adobe-CNS1-2 Adobe-CNS1-3 \
	Adobe-CNS1-4 Adobe-CNS1-5 Adobe-CNS1-6 B5-H B5-V B5pc-H B5pc-V \
	CNS-EUC-H CNS-EUC-V CNS1-H CNS1-V CNS2-H CNS2-V ETen-B5-H \
	ETen-B5-V ETenms-B5-H ETenms-B5-V ETHK-B5-H ETHK-B5-V \
	HKdla-B5-H HKdla-B5-V HKdlb-B5-H HKdlb-B5-V HKgccs-B5-H \
	HKgccs-B5-V HKm314-B5-H HKm314-B5-V HKm471-B5-H HKm471-B5-V \
	HKscs-B5-H HKscs-B5-V UniCNS-UCS2-H UniCNS-UCS2-V \
	UniCNS-UTF16-H UniCNS-UTF16-V )

CMAP_GB_FILES := $(addprefix cmaps/, \
	Adobe-GB1-0 Adobe-GB1-1 Adobe-GB1-2 Adobe-GB1-3 Adobe-GB1-4 \
	Adobe-GB1-5 GB-EUC-H GB-EUC-V GB-H GB-V GBK-EUC-H GBK-EUC-V \
	GBK2K-H GBK2K-V GBKp-EUC-H GBKp-EUC-V GBpc-EUC-H GBpc-EUC-V \
	GBT-EUC-H GBT-EUC-V GBT-H GBT-V GBTpc-EUC-H GBTpc-EUC-V \
	UniGB-UCS2-H UniGB-UCS2-V UniGB-UTF16-H UniGB-UTF16-V )

CMAP_JAPAN_FILES := $(addprefix cmaps/, \
	78-EUC-H 78-EUC-V 78-H 78-RKSJ-H 78-RKSJ-V 78-V 78ms-RKSJ-H \
	78ms-RKSJ-V 83pv-RKSJ-H 90ms-RKSJ-H 90ms-RKSJ-V 90msp-RKSJ-H \
	90msp-RKSJ-V 90pv-RKSJ-H 90pv-RKSJ-V Add-H Add-RKSJ-H \
	Add-RKSJ-V Add-V Adobe-Japan1-0 Adobe-Japan1-1 Adobe-Japan1-2 \
	Adobe-Japan1-3 Adobe-Japan1-4 Adobe-Japan1-5 Adobe-Japan1-6 \
	EUC-H EUC-V Ext-H Ext-RKSJ-H Ext-RKSJ-V Ext-V H Hankaku \
	Hiragana Katakana NWP-H NWP-V RKSJ-H RKSJ-V Roman \
	UniJIS-UCS2-H UniJIS-UCS2-HW-H UniJIS-UCS2-HW-V UniJIS-UCS2-V \
	UniJISPro-UCS2-HW-V UniJISPro-UCS2-V V WP-Symbol \
	Adobe-Japan2-0 Hojo-EUC-H Hojo-EUC-V Hojo-H Hojo-V \
	UniHojo-UCS2-H UniHojo-UCS2-V UniHojo-UTF16-H UniHojo-UTF16-V \
	UniJIS-UTF16-H UniJIS-UTF16-V )

CMAP_KOREA_FILES := $(addprefix cmaps/, \
	Adobe-Korea1-0 Adobe-Korea1-1 Adobe-Korea1-2 KSC-EUC-H \
	KSC-EUC-V KSC-H KSC-Johab-H KSC-Johab-V KSC-V KSCms-UHC-H \
	KSCms-UHC-HW-H KSCms-UHC-HW-V KSCms-UHC-V KSCpc-EUC-H \
	KSCpc-EUC-V UniKS-UCS2-H UniKS-UCS2-V UniKS-UTF16-H UniKS-UTF16-V )

ifeq "$(pregen)" ""

$(GENDIR)/cmap_unicode.c: $(CMAPDUMP_EXE) $(CMAP_UNICODE_FILES)
	$(GENFILE_CMD)
$(GENDIR)/cmap_cns.c: $(CMAPDUMP_EXE) $(CMAP_CNS_FILES)
	$(GENFILE_CMD)
$(GENDIR)/cmap_gb.c: $(CMAPDUMP_EXE) $(CMAP_GB_FILES)
	$(GENFILE_CMD)
$(GENDIR)/cmap_japan.c: $(CMAPDUMP_EXE) $(CMAP_JAPAN_FILES)
	$(GENFILE_CMD)
$(GENDIR)/cmap_korea.c: $(CMAPDUMP_EXE) $(CMAP_KOREA_FILES)
	$(GENFILE_CMD)

endif

CMAP_SRC := \
	$(GENDIR)/cmap_unicode.c \
	$(GENDIR)/cmap_cns.c \
	$(GENDIR)/cmap_gb.c \
	$(GENDIR)/cmap_japan.c \
	$(GENDIR)/cmap_korea.c

CMAP_OBJ := $(CMAP_SRC:$(GENDIR)/%.c=$(OBJDIR)/%.o)

#
# Library
#

MUPDF_LIB = $(OBJDIR)/libmupdf.a
$(MUPDF_LIB): $(FITZ_OBJ) $(DRAW_OBJ) $(MUPDF_OBJ) $(CMAP_OBJ) $(FONT_OBJ)
	 $(AR_CMD)

#
# Applications
#

APPS = $(PDFSHOW_EXE) $(PDFCLEAN_EXE) $(PDFDRAW_EXE) $(PDFEXTRACT_EXE) $(PDFINFO_EXE) $(PDFVIEW_EXE)

$(OBJDIR)/%.o: apps/%.c
	$(CC_CMD)

PDFSHOW_SRC=apps/pdfshow.c
PDFSHOW_OBJ=$(PDFSHOW_SRC:apps/%.c=$(OBJDIR)/%.o)
PDFSHOW_EXE=$(OBJDIR)/pdfshow
$(PDFSHOW_OBJ): $(MUPDF_HDR)
$(PDFSHOW_EXE): $(PDFSHOW_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD)

PDFCLEAN_SRC=apps/pdfclean.c
PDFCLEAN_OBJ=$(PDFCLEAN_SRC:apps/%.c=$(OBJDIR)/%.o)
PDFCLEAN_EXE=$(OBJDIR)/pdfclean
$(PDFCLEAN_OBJ): $(MUPDF_HDR)
$(PDFCLEAN_EXE): $(PDFCLEAN_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD)

PDFDRAW_SRC=apps/pdfdraw.c
PDFDRAW_OBJ=$(PDFDRAW_SRC:apps/%.c=$(OBJDIR)/%.o)
PDFDRAW_EXE=$(OBJDIR)/pdfdraw
$(PDFDRAW_OBJ): $(MUPDF_HDR)
$(PDFDRAW_EXE): $(PDFDRAW_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD)

PDFEXTRACT_SRC=apps/pdfextract.c
PDFEXTRACT_OBJ=$(PDFEXTRACT_SRC:apps/%.c=$(OBJDIR)/%.o)
PDFEXTRACT_EXE=$(OBJDIR)/pdfextract
$(PDFEXTRACT_OBJ): $(MUPDF_HDR)
$(PDFEXTRACT_EXE): $(PDFEXTRACT_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD)

PDFINFO_SRC=apps/pdfinfo.c
PDFINFO_OBJ=$(PDFINFO_SRC:apps/%.c=$(OBJDIR)/%.o)
PDFINFO_EXE=$(OBJDIR)/pdfinfo
$(PDFINFO_OBJ): $(MUPDF_HDR)
$(PDFINFO_EXE): $(PDFINFO_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD)

PDFAPP_HDR = apps/pdfapp.h

X11VIEW_SRC=apps/x11_main.c apps/x11_image.c apps/pdfapp.c
X11VIEW_OBJ=$(X11VIEW_SRC:apps/%.c=$(OBJDIR)/%.o)
X11VIEW_EXE=$(OBJDIR)/mupdf

$(X11VIEW_OBJ): $(MUPDF_HDR) $(PDFAPP_HDR)
$(X11VIEW_EXE): $(X11VIEW_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD) $(X11LIBS)

WINVIEW_SRC=apps/win_main.c apps/pdfapp.c
WINVIEW_RES=apps/win_res.rc
WINVIEW_OBJ=$(WINVIEW_SRC:apps/%.c=$(OBJDIR)/%.o) $(WINVIEW_RES:apps/%.rc=$(OBJDIR)/%.o)
WINVIEW_EXE=$(OBJDIR)/mupdf.exe

$(OBJDIR)/%.o: apps/%.rc
	$(WINDRES) -i $< -o $@ --include-dir=apps

$(WINVIEW_OBJ): $(MUPDF_HDR) $(PDFAPP_HDR)
$(WINVIEW_EXE): $(WINVIEW_OBJ) $(MUPDF_LIB) $(THIRD_LIBS)
	$(LD_CMD) $(W32LIBS)

#
# Default rules
#

.PHONY: default all pregen clean nuke install

all: $(OBJDIR) $(GENDIR) $(THIRD_LIBS) $(MUPDF_LIB) $(APPS)

clean:
	rm -rf $(OBJDIR)/*

nuke:
	rm -rf build

install: $(OBJDIR) $(GENDIR) $(MUPDF_LIB) $(APPS)
	install -d $(prefix)/bin $(prefix)/lib $(prefix)/include
	install $(APPS) $(prefix)/bin
	install $(MUPDF_LIB) $(prefix)/lib
	install $(MUPDF_HDR) $(prefix)/include

=== debian/changelog ===
mupdf (0.7-2) unstable; urgency=low

  * Fix FTBFS on hurd-i386, kfreebsd-amd64, kfreebsd-i386

 -- Kan-Ru Chen <koster@debian.org>  Wed, 15 Sep 2010 17:15:47 +0800

mupdf (0.7-1) unstable; urgency=low

  * New upstream release
    (Closes: #590263, #590264, #590245)
  * Update manpages to reflect keybinding change
  * Patch build system to accept additional CFLAGS.
  * Add mupdf-tools to Suggests of mupdf. (Closes: #593446)
  * Update watch file
  * Bump Standards-Version to 3.9.1, no changes needed

 -- Kan-Ru Chen <koster@debian.org>  Wed, 15 Sep 2010 02:27:06 +0800

mupdf (0.6-1) unstable; urgency=low

  * Initial release. (Closes: #559906)

 -- Kan-Ru Chen <koster@debian.org>  Thu, 22 Jul 2010 08:23:00 +0800

=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Kan-Ru Chen <koster@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libfreetype6-dev, pkg-config,
 libjpeg-dev, libjbig2dec-dev, libopenjpeg-dev, libx11-dev, libxext-dev, zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://mupdf.com/
Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 .
 This package contains the static library and headers.

Package: mupdf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: mupdf-tools
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: commmand line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 .
 This package contains command line tools using the MuPDF library:
 .
 pdfdraw to render pages to image files.
 .
 pdfshow to examine objects in a PDF file.
 .
 pdfclean to decompress and pretty print streams and objects in PDF files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

override_dh_auto_build:
	$(MAKE) build=release OS=Linux

override_dh_auto_install:
	$(MAKE) build=release OS=Linux prefix=$(CURDIR)/debian/tmp/usr install

override_dh_auto_clean:
	-rm -rf build

%:
	dh $@

=== debian/watch ===
version=3

http://mupdf.com/download/ mupdf-([\d.]+)\.tar\.gz

## mupdf 0.8.15

=== Makefile ===
--- 
+++ 
@@ -85,6 +85,7 @@
 	fitz/crypt_aes.c \
 	fitz/crypt_arc4.c \
 	fitz/crypt_md5.c \
+	fitz/crypt_sha2.c \
 	fitz/dev_bbox.c \
 	fitz/dev_draw.c \
 	fitz/dev_list.c \
@@ -303,6 +304,12 @@
 
 APPS = $(PDFSHOW_EXE) $(PDFCLEAN_EXE) $(PDFDRAW_EXE) $(PDFEXTRACT_EXE) $(PDFINFO_EXE) $(PDFVIEW_EXE)
 
+APPS_MAN = \
+	apps/man/mupdf.1 \
+	apps/man/pdfclean.1 \
+	apps/man/pdfdraw.1 \
+	apps/man/pdfshow.1
+
 $(OBJDIR)/%.o: apps/%.c
 	$(CC_CMD)
 
@@ -377,8 +384,14 @@
 nuke:
 	rm -rf build
 
+BINDIR ?= $(prefix)/bin
+LIBDIR ?= $(prefix)/lib
+INCDIR ?= $(prefix)/include
+MANDIR ?= $(prefix)/share/man/man1
+
 install: $(OBJDIR) $(GENDIR) $(MUPDF_LIB) $(APPS)
-	install -d $(prefix)/bin $(prefix)/lib $(prefix)/include
-	install $(APPS) $(prefix)/bin
-	install $(MUPDF_LIB) $(prefix)/lib
-	install $(MUPDF_HDR) $(prefix)/include
+	install -d $(BINDIR) $(LIBDIR) $(INCDIR) $(MANDIR)
+	install $(APPS) $(BINDIR)
+	install $(APPS_MAN) $(MANDIR)
+	install $(MUPDF_LIB) $(LIBDIR)
+	install $(MUPDF_HDR) $(INCDIR)

=== debian/changelog ===
mupdf (0.8.15-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Kan-Ru Chen <koster@debian.org>  Mon, 25 Jul 2011 11:04:22 +0200

mupdf (0.8.15-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/mupdf_fix_build.patch,
    debian/patches/mupdf_install_manpages_default.patch,
    debian/patches/mupdf_move_manpages_to_upstream.patch,
    debian/patches/mupdf_remove_extra_usage.patch: Merged upstream.
  * debian/watch: Upstream now uses google code hosting.

 -- Kan-Ru Chen <koster@debian.org>  Tue, 05 Apr 2011 20:03:33 +0800

mupdf (0.8-1) unstable; urgency=low

  * New upstream release. (Closes: #604746)
  * debian/patches/mupdf_move_manpages_to_upstream.patch,
    debian/patches/mupdf_update_manpages.patch: Sync with upstream.
    Remove debug purpose keybinding from manpage. (Closes: #597337)
  * Add NoDisplay=true to mupdf.desktop as the application is not
    intended for standalone use but a viewer. (Closes: #602293)
  * debian/mupdf.menu: Removed as well.
  * debian/patches/mupdf_remove_extra_usage.patch: New patch, remove
    redundant usage string from output.
  * Add non-standard DEB_BUILD_OPTIONS x-fpic support. (Closes: #617253)

 -- Kan-Ru Chen <koster@debian.org>  Wed, 09 Mar 2011 11:23:12 +0800

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,14 @@
 
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
+
+ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
+	CFLAGS += -fPIC
+endif
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	MAKEFLAGS += -j$(NUMJOBS)
+endif
 
 override_dh_auto_build:
 	$(MAKE) build=release OS=Linux

## mupdf 0.9

=== debian/changelog ===
mupdf (0.9-2+deb7u3ubuntu0.12.04.1) precise-security; urgency=medium

  * Security merge from Debian.

 -- Steve Beattie <sbeattie@ubuntu.com>  Tue, 23 Aug 2016 16:34:49 -0700

mupdf (0.9-2+deb7u3) wheezy-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * Backport fix for CVE-2016-6525: heap overflow in pdf_load_mesh_params()
    from upstream git commit 39b0f07dd960f34e7e6bf230ffc3d87c41ef0f2e.

 -- Jonas Meurer <mejo@debian.org>  Sat, 06 Aug 2016 16:13:05 +0200

mupdf (0.9-2+deb7u2) wheezy-security; urgency=high

  * Fix header mismatch with libjpeg-dev.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 04 Jun 2014 22:46:25 +0800

mupdf (0.9-2+deb7u1) wheezy-security; urgency=high

  * Backport fix of CVE-2014-2013: Stack-based Buffer Overflow in
    xps_parse_color() from unstable. (Closes: #738857)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 03 Jun 2014 23:59:34 +0800

mupdf (0.9-2ubuntu1) precise; urgency=low

  * d/p/ignore_scripts.patch: (LP: #934999)
    - Don't use included jconfig.h, use the system one instead.

 -- Andreas Moog <amoog@ubuntu.com>  Sat, 18 Feb 2012 21:38:55 +0100

mupdf (0.9-2) unstable; urgency=low

  * Enable harden flags.
  * debian/copyright: Updated.
  * Bump Standards-Version to 3.9.2, no changes needed
  * debian/patches/bug621894.patch: Fix text copying with
    selection. (Closes: #621894)
  * debian/patches/bug646350.patch: Fix FTBFS with
    -Werror=format-security. (Closes: #646350)

 -- Kan-Ru Chen <koster@debian.org>  Sat, 17 Dec 2011 22:25:35 +0800

mupdf (0.9-1) unstable; urgency=low

  * New upstream release. (Closes: #641169)
  * debian/patches/mupdf_update_manpages.patch: Merged upstream.
  * debian/libmupdf-dev.install: Install more library and headers.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 11 Sep 2011 12:08:18 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Kan-Ru Chen <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libfreetype6-dev, pkg-config,
- libjpeg-dev, libjbig2dec-dev, libopenjpeg-dev, libx11-dev, libxext-dev, zlib1g-dev
-Standards-Version: 3.9.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kan-Ru Chen <koster@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
+ libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
+ libopenjpeg-dev, libx11-dev, libxext-dev, zlib1g-dev
+Standards-Version: 3.9.2
 Homepage: http://mupdf.com/
 Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
 Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -fPIC
@@ -16,6 +19,8 @@
 endif
 
 override_dh_auto_build:
+	# Use system libjpeg jconfig.h
+	-rm scripts/jconfig.h
 	$(MAKE) build=release OS=Linux
 
 override_dh_auto_install:

=== debian/watch ===
version=3
opts=\
downloadurlmangle=s|.*[?]name=(.*?)&.*|http://mupdf.googlecode.com/files/$1|,\
filenamemangle=s|[^/]+[?]name=mupdf-(.*?)-source\.tar\.gz&.*|mupdf-$1\.tar\.gz| \
http://code.google.com/p/mupdf/downloads/detail[?]name=mupdf-([0-9.]+)-source\.tar\.gz&.*

## mupdf 1.0%2b-git-20120814

=== thirdparty/openjpeg-1.5.0/applications/jpip/CMakeLists.txt ===
# required dep for server:
IF(BUILD_JPIP_SERVER)
  FIND_PACKAGE(CURL REQUIRED)
  FIND_PACKAGE(FCGI REQUIRED)
  FIND_PACKAGE(PTHREAD REQUIRED)
ENDIF(BUILD_JPIP_SERVER)

# JPIP library:
ADD_SUBDIRECTORY(libopenjpip)

# JPIP binaries:
ADD_SUBDIRECTORY(util)

=== thirdparty/openjpeg-1.5.0/libopenjpeg/jpwl/CMakeLists.txt ===
# Makefile for the main JPWL OpenJPEG codecs: JPWL_ j2k_to_image and JPWL_image_to_j2k

ADD_DEFINITIONS(-DUSE_JPWL)

SET(JPWL_SRCS crc.c jpwl.c jpwl_lib.c rs.c)
IF(APPLE)
  SET_SOURCE_FILES_PROPERTIES(
    rs.c
    PROPERTIES
    COMPILE_FLAGS -fno-common)
ENDIF(APPLE)

INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  )

# Build the library
IF(WIN32)
  IF(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_EXPORTS)
  ELSE(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_STATIC)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(WIN32)
ADD_LIBRARY(${OPENJPEG_LIBRARY_NAME}_JPWL ${JPWL_SRCS} ${OPENJPEG_SRCS})
SET_TARGET_PROPERTIES(${OPENJPEG_LIBRARY_NAME}_JPWL 
  PROPERTIES ${OPENJPEG_LIBRARY_PROPERTIES})

# Install library
INSTALL(TARGETS ${OPENJPEG_LIBRARY_NAME}_JPWL
  DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
)

=== thirdparty/openjpeg-1.5.0/applications/jpip/libopenjpip/CMakeLists.txt ===
INCLUDE_REGULAR_EXPRESSION("^.*$")

INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${FCGI_INCLUDE_DIRS}
  ${CURL_INCLUDE_DIRS}
  ${PTHREAD_INCLUDE_DIRS}
)

# Defines the source code for the library
SET(OPENJPIP_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/boxheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/codestream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgreg_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/marker_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/msgqueue_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/box_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/faixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/index_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/metadata_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/placeholder_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/byte_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/ihdrbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/manfbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mhixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/target_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cachemodel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/j2kheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_encoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpip.c
  ${CMAKE_CURRENT_SOURCE_DIR}/query_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/channel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/session_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpip_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sock_manager.c
  )

SET(SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/auxtrans_manager.c
  )

SET(LOCAL_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_decoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgsock_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpipstream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cache_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dec_clientmsg_handler.c
  )

# Build the library
ADD_LIBRARY(openjpip_local STATIC ${OPENJPIP_SRCS} ${LOCAL_SRCS})
TARGET_LINK_LIBRARIES(openjpip_local ${OPENJPEG_LIBRARY_NAME})
IF(WIN32)
  # add Winsock on windows+mingw
  TARGET_LINK_LIBRARIES(openjpip_local ws2_32)
ENDIF(WIN32)

# Install library
INSTALL(TARGETS openjpip_local
  EXPORT OpenJPEGTargets
  DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  )

IF(BUILD_JPIP_SERVER)
  ADD_LIBRARY(openjpip_server STATIC ${OPENJPIP_SRCS} ${SERVER_SRCS})
  TARGET_LINK_LIBRARIES(openjpip_server ${FCGI_LIBRARIES} ${CURL_LIBRARIES} ${PTHREAD_LIBRARIES})
  SET_TARGET_PROPERTIES(openjpip_server
    PROPERTIES COMPILE_FLAGS "-DSERVER")
  INSTALL(TARGETS openjpip_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
    )
ENDIF(BUILD_JPIP_SERVER)

=== debian/changelog ===
mupdf (1.0+-git-20120814) unstable; urgency=low

  * ...

 -- Frank Fuhlbrück <frafl@justmail.de>  Sun, 02 Sep 2012 09:11:00 +0200

## mupdf 1.1%2b-git-20120926

=== thirdparty/openjpeg/CMakeLists.txt ===
# Main CMakeLists.txt to build the OpenJPEG project using CMake (www.cmake.org)
# Written by Mathieu Malaterre

# This CMake project will by default create a library called openjpeg
# But if you want to use this project within your own (CMake) project
# you will eventually like to prefix the library to avoid linking confusion
# For this purpose you can define a CMake var: OPENJPEG_NAMESPACE to whatever you like
# e.g.:
# SET(OPENJPEG_NAMESPACE "GDCMOPENJPEG")
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

IF(NOT OPENJPEG_NAMESPACE)
  SET(OPENJPEG_NAMESPACE "OPENJPEG")
  SET(OPENJPEG_STANDALONE 1)
ENDIF(NOT OPENJPEG_NAMESPACE)
# In all cases:
STRING(TOLOWER ${OPENJPEG_NAMESPACE} OPENJPEG_LIBRARY_NAME)

PROJECT(${OPENJPEG_NAMESPACE} C)

# Do full dependency headers.
INCLUDE_REGULAR_EXPRESSION("^.*$")

#-----------------------------------------------------------------------------
# OPENJPEG version number, useful for packaging and doxygen doc:
SET(OPENJPEG_VERSION_MAJOR 1)
SET(OPENJPEG_VERSION_MINOR 5)
SET(OPENJPEG_VERSION_BUILD 0)
SET(OPENJPEG_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")
SET(PACKAGE_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")
SET(OPENJPEG_LIBRARY_PROPERTIES
  VERSION   "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}"
  SOVERSION "${OPENJPEG_VERSION_MAJOR}"
)

# --------------------------------------------------------------------------
# Path to additional CMake modules
SET(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}/CMake
    ${CMAKE_MODULE_PATH})

# --------------------------------------------------------------------------
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(WIN32)
  IF(NOT BORLAND)
    IF(NOT CYGWIN)
      IF(NOT MINGW)
        IF(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
          ADD_DEFINITIONS(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
        ENDIF(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
      ENDIF(NOT MINGW)
    ENDIF(NOT CYGWIN)
  ENDIF(NOT BORLAND)
ENDIF(WIN32)


# --------------------------------------------------------------------------
# Install directories

STRING(TOLOWER ${PROJECT_NAME} projectname)
SET(OPENJPEG_INSTALL_SUBDIR "${projectname}-${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}")

IF(NOT OPENJPEG_INSTALL_BIN_DIR)
  SET(OPENJPEG_INSTALL_BIN_DIR "bin")
ENDIF(NOT OPENJPEG_INSTALL_BIN_DIR)

IF(NOT OPENJPEG_INSTALL_LIB_DIR)
  SET(OPENJPEG_INSTALL_LIB_DIR "lib")
ENDIF(NOT OPENJPEG_INSTALL_LIB_DIR)

IF(NOT OPENJPEG_INSTALL_SHARE_DIR)
  SET(OPENJPEG_INSTALL_SHARE_DIR "share")
ENDIF(NOT OPENJPEG_INSTALL_SHARE_DIR)

IF(NOT OPENJPEG_INSTALL_DATA_DIR)
  SET(OPENJPEG_INSTALL_DATA_DIR "${OPENJPEG_INSTALL_SHARE_DIR}/${OPENJPEG_INSTALL_SUBDIR}")
ENDIF(NOT OPENJPEG_INSTALL_DATA_DIR)

IF(NOT OPENJPEG_INSTALL_INCLUDE_DIR)
  SET(OPENJPEG_INSTALL_INCLUDE_DIR "include/")
ENDIF(NOT OPENJPEG_INSTALL_INCLUDE_DIR)

IF(NOT OPENJPEG_INSTALL_MAN_DIR)
  SET(OPENJPEG_INSTALL_MAN_DIR "share/man/")
ENDIF(NOT OPENJPEG_INSTALL_MAN_DIR)

IF(NOT OPENJPEG_INSTALL_DOC_DIR)
  SET(OPENJPEG_INSTALL_DOC_DIR "share/doc/${OPENJPEG_INSTALL_SUBDIR}")
ENDIF(NOT OPENJPEG_INSTALL_DOC_DIR)

IF(NOT OPENJPEG_INSTALL_PACKAGE_DIR)
  SET(OPENJPEG_INSTALL_PACKAGE_DIR "${OPENJPEG_INSTALL_SHARE_DIR}/${OPENJPEG_INSTALL_SUBDIR}")
ENDIF(NOT OPENJPEG_INSTALL_PACKAGE_DIR)

#-----------------------------------------------------------------------------
# Big endian test:
INCLUDE (${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
TEST_BIG_ENDIAN(OPJ_BIG_ENDIAN)

#-----------------------------------------------------------------------------
# Setup file for setting custom ctest vars
CONFIGURE_FILE(
  ${CMAKE_SOURCE_DIR}/CMake/CTestCustom.cmake.in
  ${CMAKE_BINARY_DIR}/CTestCustom.cmake
  @ONLY
  )

#-----------------------------------------------------------------------------
# OpenJPEG build configuration options.
OPTION(BUILD_SHARED_LIBS "Build OpenJPEG shared library and link executables against it." ON)
SET (EXECUTABLE_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables.")
SET (LIBRARY_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries.")
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

#-----------------------------------------------------------------------------
# configure name mangling to allow multiple libraries to coexist
# peacefully
IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)
SET(MANGLE_PREFIX ${OPENJPEG_LIBRARY_NAME})
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/openjpeg_mangle.h
               @ONLY)
ENDIF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)

#-----------------------------------------------------------------------------
# pkgconfig support
IF(UNIX)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libopenjpeg1.pc.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/libopenjpeg1.pc @ONLY)
  INSTALL( FILES  ${CMAKE_CURRENT_BINARY_DIR}/libopenjpeg1.pc DESTINATION
    ${OPENJPEG_INSTALL_SHARE_DIR}/pkgconfig )
  INSTALL( CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink
  \"libopenjpeg1.pc\"
  \"\$ENV{DESTDIR}${OPENJPEG_INSTALL_LIB_DIR}/pkgconfig/libopenjpeg.pc\")")
ENDIF(UNIX)

#-----------------------------------------------------------------------------
# Compiler specific flags:
IF(CMAKE_COMPILER_IS_GNUCC)
  # For all builds, make sure openjpeg is std99 compliant:
  # SET(CMAKE_C_FLAGS "-Wall -std=c99 ${CMAKE_C_FLAGS}") # FIXME: this setting prevented us from setting a coverage build.
  # Do not use ffast-math for all build, it would produce incorrect results, only set for release:
  SET(CMAKE_C_FLAGS_RELEASE "-ffast-math ${CMAKE_C_FLAGS_RELEASE}")
ENDIF(CMAKE_COMPILER_IS_GNUCC)

#-----------------------------------------------------------------------------
# opj_config.h generation (1/2)
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
CHECK_INCLUDE_FILE("strings.h"      HAVE_STRINGS_H)
CHECK_INCLUDE_FILE("inttypes.h"     HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE("memory.h"       HAVE_MEMORY_H)
CHECK_INCLUDE_FILE("stdint.h"       HAVE_STDINT_H)
CHECK_INCLUDE_FILE("stdlib.h"       HAVE_STDLIB_H)
CHECK_INCLUDE_FILE("string.h"       HAVE_STRING_H)
CHECK_INCLUDE_FILE("sys/stat.h"     HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE("sys/types.h"    HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE("unistd.h"       HAVE_UNISTD_H)


#-----------------------------------------------------------------------------
# Build Library
INCLUDE_DIRECTORIES(BEFORE ${OPENJPEG_BINARY_DIR})
ADD_SUBDIRECTORY(libopenjpeg)

#-----------------------------------------------------------------------------
# Build Applications
OPTION(BUILD_CODEC "Build the CODEC executables" ON)
OPTION(BUILD_MJ2 "Build the MJ2 executables." OFF)
OPTION(BUILD_JPWL "Build the JPWL library and executables" OFF)
OPTION(BUILD_JPIP "Build the JPIP library and executables." OFF)
IF(BUILD_JPIP)
  OPTION(BUILD_JPIP_SERVER "Build the JPIP server." OFF)
ENDIF(BUILD_JPIP)
OPTION(BUILD_VIEWER "Build the OPJViewer executable (C++)" OFF)
OPTION(BUILD_JAVA "Build the openjpeg jar (Java)" OFF)
MARK_AS_ADVANCED(BUILD_VIEWER)
MARK_AS_ADVANCED(BUILD_JAVA)

IF(BUILD_CODEC OR BUILD_MJ2)
  # OFF: It will only build 3rd party libs if they are not found on the system
  # ON: 3rd party libs will ALWAYS be build, and used
  OPTION(BUILD_THIRDPARTY "Build the thirdparty executables if it is needed" OFF)
  ADD_SUBDIRECTORY(thirdparty)
  ADD_SUBDIRECTORY(applications)
ENDIF (BUILD_CODEC OR BUILD_MJ2)

#-----------------------------------------------------------------------------
# opj_config.h generation (2/2)
CONFIGURE_FILE("${OPENJPEG_SOURCE_DIR}/opj_config.h.cmake.in"
 "${OPENJPEG_BINARY_DIR}/opj_config.h"
 @ONLY
 )

#-----------------------------------------------------------------------------
# Build DOCUMENTATION (not in ALL target and only if Doxygen is found)
OPTION(BUILD_DOC "Build the HTML documentation (with doxygen if available)." OFF)
IF(BUILD_DOC)
    ADD_SUBDIRECTORY(doc)
ENDIF(BUILD_DOC)

#-----------------------------------------------------------------------------
# Buld Testing
OPTION(BUILD_TESTING "Build the tests." OFF)
IF(BUILD_TESTING)
  IF(BUILD_CODEC)
    ENABLE_TESTING()
    INCLUDE(CTest)
  
    # Search openjpeg data needed for the tests
    # They could be found via svn on the OpenJPEG google code project
    # svn checkout http://openjpeg.googlecode.com/svn/data (about 70 Mo) 
    FIND_PATH(OPJ_DATA_ROOT README-OPJ-Data
      PATHS
      $ENV{OPJ_DATA_ROOT}
      ${CMAKE_SOURCE_DIR}/../data
      )

    # Add repository where to find tests
    ADD_SUBDIRECTORY(tests)
    
  ELSE(BUILD_CODEC)
    message(FATAL_ERROR "You need build codec to run the tests")
  ENDIF(BUILD_CODEC)
ENDIF(BUILD_TESTING)

#-----------------------------------------------------------------------------
# install all targets referenced as OPENJPEGTargets
INSTALL(EXPORT OpenJPEGTargets DESTINATION ${OPENJPEG_INSTALL_PACKAGE_DIR})
CONFIGURE_FILE( ${OPENJPEG_SOURCE_DIR}/CMake/OpenJPEGConfig.cmake.in
  ${OPENJPEG_BINARY_DIR}/OpenJPEGConfig.cmake
  @ONLY
)
INSTALL( FILES ${OPENJPEG_BINARY_DIR}/OpenJPEGConfig.cmake
  DESTINATION ${OPENJPEG_INSTALL_PACKAGE_DIR}
)

#-----------------------------------------------------------------------------
# install CHANGES and LICENSE
INSTALL(
  FILES       CHANGES 
              LICENSE
  DESTINATION ${OPENJPEG_INSTALL_DOC_DIR})

INCLUDE (CMake/OpenJPEGCPack.cmake)

=== thirdparty/openjpeg/applications/jpip/util/CMakeLists.txt ===
# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/applications/jpip/libopenjpip
  ${FCGI_INCLUDE_DIRS}
)

IF(BUILD_JPIP_SERVER)
  
  SET(OPJ_SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_server.c
  )
  
  # Build executable
  ADD_EXECUTABLE(opj_server ${OPJ_SERVER_SRCS})
  TARGET_LINK_LIBRARIES(opj_server openjpip_server)
  SET_PROPERTY(
    TARGET opj_server
    APPEND PROPERTY
    COMPILE_DEFINITIONS SERVER QUIT_SIGNAL="quitJPIP"
    )

  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(opj_server m)
  ENDIF(UNIX)

  # Install exe
  INSTALL(TARGETS opj_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
ENDIF(BUILD_JPIP_SERVER)

SET(EXES
  opj_dec_server
  jpip_to_jp2
  jpip_to_j2k
  test_index
  )
FOREACH(exe ${EXES})
  ADD_EXECUTABLE(${exe} ${exe}.c)
  TARGET_LINK_LIBRARIES(${exe} openjpip_local)
  INSTALL(TARGETS ${exe}
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
ENDFOREACH(exe)

# Build the two java clients:
FIND_PACKAGE(Java 1.5 REQUIRED) # javac, jar

# 1. opj_viewer
# build dep list:
file(GLOB java1_srcs "opj_viewer/src/*.java")

# make sure target javac dir exists:
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes1)
# Build java
ADD_CUSTOM_COMMAND(
  OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
  COMMAND ${Java_JAVAC_EXECUTABLE} 
  ${java1_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes1
  COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt -C
  ${CMAKE_CURRENT_BINARY_DIR}/classes1 .
  DEPENDS ${java1_srcs}
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt
  COMMENT "javac *.java; jar cvf -> opj_viewer.jar"
)

# name the target
ADD_CUSTOM_TARGET(OPJViewerJar ALL
  DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
  COMMENT "building opj_viewer.jar"
)

# 2. opj_viewer_xerces
# search for package org.apache.xerces.parsers
find_file(APACHE_XERCES_JAR
  NAMES xerces-j2.jar xercesImpl.jar
  PATHS /usr/share/java/
  NO_DEFAULT_PATH
  )
mark_as_advanced(APACHE_XERCES_JAR)

if(EXISTS ${APACHE_XERCES_JAR})
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
    ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt
    @ONLY
    )
  # build dep list:
  file(GLOB java2_srcs "opj_viewer_xerces/src/*.java")

  # Need some common files:
  list(APPEND java2_srcs
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImageManager.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImgdecClient.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/JPIPHttpClient.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/MML.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/PnmImage.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/RegimViewer.java
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ResizeListener.java
    )

  # make sure target javac dir exists:
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes2)
  # Build java
  ADD_CUSTOM_COMMAND(
    OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
    COMMAND ${Java_JAVAC_EXECUTABLE} 
    -classpath ${APACHE_XERCES_JAR}
    ${java2_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes2
    COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
    ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt 
    -C ${CMAKE_CURRENT_BINARY_DIR}/classes2 .
    DEPENDS ${java2_srcs}
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
    COMMENT "javac *.java; jar cvf -> opj_viewer_xerces.jar"
    )

  # name the target
  ADD_CUSTOM_TARGET(OPJViewerXercesJar ALL
    DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
    COMMENT "building opj_viewer_xerces.jar"
    )
endif()

=== debian/changelog ===
mupdf (1.1+-git-20120926) unstable; urgency=low

  * add memento.h to libmupdf-dev

 -- Frank Fuhlbrück <frafl@justmail.de>  Mon, 03 Sep 2012 23:14:19 +0200
